<?php

namespace TurnedAwayBOSS\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfApplicantGroup ArrayType
 * @subpackage Arrays
 */
class ArrayOfApplicantGroup extends AbstractStructArrayBase
{
    /**
     * The ApplicantGroup
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \TurnedAwayBOSS\StructType\ApplicantGroup[]
     */
    public $ApplicantGroup;
    /**
     * Constructor method for ArrayOfApplicantGroup
     * @uses ArrayOfApplicantGroup::setApplicantGroup()
     * @param \TurnedAwayBOSS\StructType\ApplicantGroup[] $applicantGroup
     */
    public function __construct(array $applicantGroup = array())
    {
        $this
            ->setApplicantGroup($applicantGroup);
    }
    /**
     * Get ApplicantGroup value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \TurnedAwayBOSS\StructType\ApplicantGroup[]|null
     */
    public function getApplicantGroup()
    {
        return isset($this->ApplicantGroup) ? $this->ApplicantGroup : null;
    }
    /**
     * This method is responsible for validating the values passed to the setApplicantGroup method
     * This method is willingly generated in order to preserve the one-line inline validation within the setApplicantGroup method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateApplicantGroupForArrayConstraintsFromSetApplicantGroup(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfApplicantGroupApplicantGroupItem) {
            // validation for constraint: itemType
            if (!$arrayOfApplicantGroupApplicantGroupItem instanceof \TurnedAwayBOSS\StructType\ApplicantGroup) {
                $invalidValues[] = is_object($arrayOfApplicantGroupApplicantGroupItem) ? get_class($arrayOfApplicantGroupApplicantGroupItem) : sprintf('%s(%s)', gettype($arrayOfApplicantGroupApplicantGroupItem), var_export($arrayOfApplicantGroupApplicantGroupItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ApplicantGroup property can only contain items of type \TurnedAwayBOSS\StructType\ApplicantGroup, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ApplicantGroup value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \TurnedAwayBOSS\StructType\ApplicantGroup[] $applicantGroup
     * @return \TurnedAwayBOSS\ArrayType\ArrayOfApplicantGroup
     */
    public function setApplicantGroup(array $applicantGroup = array())
    {
        // validation for constraint: array
        if ('' !== ($applicantGroupArrayErrorMessage = self::validateApplicantGroupForArrayConstraintsFromSetApplicantGroup($applicantGroup))) {
            throw new \InvalidArgumentException($applicantGroupArrayErrorMessage, __LINE__);
        }
        if (is_null($applicantGroup) || (is_array($applicantGroup) && empty($applicantGroup))) {
            unset($this->ApplicantGroup);
        } else {
            $this->ApplicantGroup = $applicantGroup;
        }
        return $this;
    }
    /**
     * Add item to ApplicantGroup value
     * @throws \InvalidArgumentException
     * @param \TurnedAwayBOSS\StructType\ApplicantGroup $item
     * @return \TurnedAwayBOSS\ArrayType\ArrayOfApplicantGroup
     */
    public function addToApplicantGroup(\TurnedAwayBOSS\StructType\ApplicantGroup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \TurnedAwayBOSS\StructType\ApplicantGroup) {
            throw new \InvalidArgumentException(sprintf('The ApplicantGroup property can only contain items of type \TurnedAwayBOSS\StructType\ApplicantGroup, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ApplicantGroup[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \TurnedAwayBOSS\StructType\ApplicantGroup|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \TurnedAwayBOSS\StructType\ApplicantGroup|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \TurnedAwayBOSS\StructType\ApplicantGroup|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \TurnedAwayBOSS\StructType\ApplicantGroup|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \TurnedAwayBOSS\StructType\ApplicantGroup|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ApplicantGroup
     */
    public function getAttributeName()
    {
        return 'ApplicantGroup';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \TurnedAwayBOSS\ArrayType\ArrayOfApplicantGroup
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
