<?php

namespace TurnedAwayBOSS\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfApplicantProperty ArrayType
 * @subpackage Arrays
 */
class ArrayOfApplicantProperty extends AbstractStructArrayBase
{
    /**
     * The ApplicantProperty
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \TurnedAwayBOSS\StructType\ApplicantProperty[]
     */
    public $ApplicantProperty;
    /**
     * Constructor method for ArrayOfApplicantProperty
     * @uses ArrayOfApplicantProperty::setApplicantProperty()
     * @param \TurnedAwayBOSS\StructType\ApplicantProperty[] $applicantProperty
     */
    public function __construct(array $applicantProperty = array())
    {
        $this
            ->setApplicantProperty($applicantProperty);
    }
    /**
     * Get ApplicantProperty value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \TurnedAwayBOSS\StructType\ApplicantProperty[]|null
     */
    public function getApplicantProperty()
    {
        return isset($this->ApplicantProperty) ? $this->ApplicantProperty : null;
    }
    /**
     * This method is responsible for validating the values passed to the setApplicantProperty method
     * This method is willingly generated in order to preserve the one-line inline validation within the setApplicantProperty method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateApplicantPropertyForArrayConstraintsFromSetApplicantProperty(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfApplicantPropertyApplicantPropertyItem) {
            // validation for constraint: itemType
            if (!$arrayOfApplicantPropertyApplicantPropertyItem instanceof \TurnedAwayBOSS\StructType\ApplicantProperty) {
                $invalidValues[] = is_object($arrayOfApplicantPropertyApplicantPropertyItem) ? get_class($arrayOfApplicantPropertyApplicantPropertyItem) : sprintf('%s(%s)', gettype($arrayOfApplicantPropertyApplicantPropertyItem), var_export($arrayOfApplicantPropertyApplicantPropertyItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ApplicantProperty property can only contain items of type \TurnedAwayBOSS\StructType\ApplicantProperty, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ApplicantProperty value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \TurnedAwayBOSS\StructType\ApplicantProperty[] $applicantProperty
     * @return \TurnedAwayBOSS\ArrayType\ArrayOfApplicantProperty
     */
    public function setApplicantProperty(array $applicantProperty = array())
    {
        // validation for constraint: array
        if ('' !== ($applicantPropertyArrayErrorMessage = self::validateApplicantPropertyForArrayConstraintsFromSetApplicantProperty($applicantProperty))) {
            throw new \InvalidArgumentException($applicantPropertyArrayErrorMessage, __LINE__);
        }
        if (is_null($applicantProperty) || (is_array($applicantProperty) && empty($applicantProperty))) {
            unset($this->ApplicantProperty);
        } else {
            $this->ApplicantProperty = $applicantProperty;
        }
        return $this;
    }
    /**
     * Add item to ApplicantProperty value
     * @throws \InvalidArgumentException
     * @param \TurnedAwayBOSS\StructType\ApplicantProperty $item
     * @return \TurnedAwayBOSS\ArrayType\ArrayOfApplicantProperty
     */
    public function addToApplicantProperty(\TurnedAwayBOSS\StructType\ApplicantProperty $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \TurnedAwayBOSS\StructType\ApplicantProperty) {
            throw new \InvalidArgumentException(sprintf('The ApplicantProperty property can only contain items of type \TurnedAwayBOSS\StructType\ApplicantProperty, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ApplicantProperty[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \TurnedAwayBOSS\StructType\ApplicantProperty|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \TurnedAwayBOSS\StructType\ApplicantProperty|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \TurnedAwayBOSS\StructType\ApplicantProperty|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \TurnedAwayBOSS\StructType\ApplicantProperty|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \TurnedAwayBOSS\StructType\ApplicantProperty|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ApplicantProperty
     */
    public function getAttributeName()
    {
        return 'ApplicantProperty';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \TurnedAwayBOSS\ArrayType\ArrayOfApplicantProperty
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
