<?php

namespace TurnedAwayBOSS\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfExistingMortgage ArrayType
 * @subpackage Arrays
 */
class ArrayOfExistingMortgage extends AbstractStructArrayBase
{
    /**
     * The ExistingMortgage
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \TurnedAwayBOSS\StructType\ExistingMortgage[]
     */
    public $ExistingMortgage;
    /**
     * Constructor method for ArrayOfExistingMortgage
     * @uses ArrayOfExistingMortgage::setExistingMortgage()
     * @param \TurnedAwayBOSS\StructType\ExistingMortgage[] $existingMortgage
     */
    public function __construct(array $existingMortgage = array())
    {
        $this
            ->setExistingMortgage($existingMortgage);
    }
    /**
     * Get ExistingMortgage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \TurnedAwayBOSS\StructType\ExistingMortgage[]|null
     */
    public function getExistingMortgage()
    {
        return isset($this->ExistingMortgage) ? $this->ExistingMortgage : null;
    }
    /**
     * This method is responsible for validating the values passed to the setExistingMortgage method
     * This method is willingly generated in order to preserve the one-line inline validation within the setExistingMortgage method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateExistingMortgageForArrayConstraintsFromSetExistingMortgage(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfExistingMortgageExistingMortgageItem) {
            // validation for constraint: itemType
            if (!$arrayOfExistingMortgageExistingMortgageItem instanceof \TurnedAwayBOSS\StructType\ExistingMortgage) {
                $invalidValues[] = is_object($arrayOfExistingMortgageExistingMortgageItem) ? get_class($arrayOfExistingMortgageExistingMortgageItem) : sprintf('%s(%s)', gettype($arrayOfExistingMortgageExistingMortgageItem), var_export($arrayOfExistingMortgageExistingMortgageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ExistingMortgage property can only contain items of type \TurnedAwayBOSS\StructType\ExistingMortgage, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ExistingMortgage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \TurnedAwayBOSS\StructType\ExistingMortgage[] $existingMortgage
     * @return \TurnedAwayBOSS\ArrayType\ArrayOfExistingMortgage
     */
    public function setExistingMortgage(array $existingMortgage = array())
    {
        // validation for constraint: array
        if ('' !== ($existingMortgageArrayErrorMessage = self::validateExistingMortgageForArrayConstraintsFromSetExistingMortgage($existingMortgage))) {
            throw new \InvalidArgumentException($existingMortgageArrayErrorMessage, __LINE__);
        }
        if (is_null($existingMortgage) || (is_array($existingMortgage) && empty($existingMortgage))) {
            unset($this->ExistingMortgage);
        } else {
            $this->ExistingMortgage = $existingMortgage;
        }
        return $this;
    }
    /**
     * Add item to ExistingMortgage value
     * @throws \InvalidArgumentException
     * @param \TurnedAwayBOSS\StructType\ExistingMortgage $item
     * @return \TurnedAwayBOSS\ArrayType\ArrayOfExistingMortgage
     */
    public function addToExistingMortgage(\TurnedAwayBOSS\StructType\ExistingMortgage $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \TurnedAwayBOSS\StructType\ExistingMortgage) {
            throw new \InvalidArgumentException(sprintf('The ExistingMortgage property can only contain items of type \TurnedAwayBOSS\StructType\ExistingMortgage, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ExistingMortgage[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \TurnedAwayBOSS\StructType\ExistingMortgage|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \TurnedAwayBOSS\StructType\ExistingMortgage|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \TurnedAwayBOSS\StructType\ExistingMortgage|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \TurnedAwayBOSS\StructType\ExistingMortgage|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \TurnedAwayBOSS\StructType\ExistingMortgage|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ExistingMortgage
     */
    public function getAttributeName()
    {
        return 'ExistingMortgage';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \TurnedAwayBOSS\ArrayType\ArrayOfExistingMortgage
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
