<?php

namespace TurnedAwayBOSS;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Login' => '\\TurnedAwayBOSS\\StructType\\Login',
            'LoginResponse' => '\\TurnedAwayBOSS\\StructType\\LoginResponse',
            'Logout' => '\\TurnedAwayBOSS\\StructType\\Logout',
            'LogoutResponse' => '\\TurnedAwayBOSS\\StructType\\LogoutResponse',
            'PullNextDeal' => '\\TurnedAwayBOSS\\StructType\\PullNextDeal',
            'PullNextDealResponse' => '\\TurnedAwayBOSS\\StructType\\PullNextDealResponse',
            'PullNextUpdatedDeal' => '\\TurnedAwayBOSS\\StructType\\PullNextUpdatedDeal',
            'PullNextUpdatedDealResponse' => '\\TurnedAwayBOSS\\StructType\\PullNextUpdatedDealResponse',
            'PullSpecificDeal' => '\\TurnedAwayBOSS\\StructType\\PullSpecificDeal',
            'PullSpecificDealResponse' => '\\TurnedAwayBOSS\\StructType\\PullSpecificDealResponse',
            'ListAvailableDeals' => '\\TurnedAwayBOSS\\StructType\\ListAvailableDeals',
            'ListAvailableDealsResponse' => '\\TurnedAwayBOSS\\StructType\\ListAvailableDealsResponse',
            'ListUpdatedDeals' => '\\TurnedAwayBOSS\\StructType\\ListUpdatedDeals',
            'ListUpdatedDealsResponse' => '\\TurnedAwayBOSS\\StructType\\ListUpdatedDealsResponse',
            'AckPullDeal' => '\\TurnedAwayBOSS\\StructType\\AckPullDeal',
            'AckPullDealResponse' => '\\TurnedAwayBOSS\\StructType\\AckPullDealResponse',
            'AckSpecificSubmission' => '\\TurnedAwayBOSS\\StructType\\AckSpecificSubmission',
            'AckSpecificSubmissionResponse' => '\\TurnedAwayBOSS\\StructType\\AckSpecificSubmissionResponse',
            'CountAvailableDeals' => '\\TurnedAwayBOSS\\StructType\\CountAvailableDeals',
            'CountAvailableDealsResponse' => '\\TurnedAwayBOSS\\StructType\\CountAvailableDealsResponse',
            'PullDocumentList' => '\\TurnedAwayBOSS\\StructType\\PullDocumentList',
            'PullDocumentListResponse' => '\\TurnedAwayBOSS\\StructType\\PullDocumentListResponse',
            'PullDocument' => '\\TurnedAwayBOSS\\StructType\\PullDocument',
            'PullDocumentResponse' => '\\TurnedAwayBOSS\\StructType\\PullDocumentResponse',
            'PullDocuments' => '\\TurnedAwayBOSS\\StructType\\PullDocuments',
            'PullDocumentsResponse' => '\\TurnedAwayBOSS\\StructType\\PullDocumentsResponse',
            'PushResponse' => '\\TurnedAwayBOSS\\StructType\\PushResponse',
            'PushResponseResponse' => '\\TurnedAwayBOSS\\StructType\\PushResponseResponse',
            'GetNetworkAndBrand' => '\\TurnedAwayBOSS\\StructType\\GetNetworkAndBrand',
            'GetNetworkAndBrandResponse' => '\\TurnedAwayBOSS\\StructType\\GetNetworkAndBrandResponse',
            'NetworkBrand' => '\\TurnedAwayBOSS\\StructType\\NetworkBrand',
            'PushDeal' => '\\TurnedAwayBOSS\\StructType\\PushDeal',
            'Deal' => '\\TurnedAwayBOSS\\StructType\\Deal',
            'LeadWorkflow' => '\\TurnedAwayBOSS\\StructType\\LeadWorkflow',
            'Broker' => '\\TurnedAwayBOSS\\StructType\\Broker',
            'DealInfo' => '\\TurnedAwayBOSS\\StructType\\DealInfo',
            'ArrayOfDownPayment' => '\\TurnedAwayBOSS\\ArrayType\\ArrayOfDownPayment',
            'DownPayment' => '\\TurnedAwayBOSS\\StructType\\DownPayment',
            'ArrayOfMortgageRequest' => '\\TurnedAwayBOSS\\ArrayType\\ArrayOfMortgageRequest',
            'MortgageRequest' => '\\TurnedAwayBOSS\\StructType\\MortgageRequest',
            'Rate' => '\\TurnedAwayBOSS\\StructType\\Rate',
            'SubjectProperty' => '\\TurnedAwayBOSS\\StructType\\SubjectProperty',
            'SubjectPropertyAddress' => '\\TurnedAwayBOSS\\StructType\\SubjectPropertyAddress',
            'Address' => '\\TurnedAwayBOSS\\StructType\\Address',
            'ApplicantAddress' => '\\TurnedAwayBOSS\\StructType\\ApplicantAddress',
            'ArrayOfPropertyExpense' => '\\TurnedAwayBOSS\\ArrayType\\ArrayOfPropertyExpense',
            'PropertyExpense' => '\\TurnedAwayBOSS\\StructType\\PropertyExpense',
            'PropertyRentalIncome' => '\\TurnedAwayBOSS\\StructType\\PropertyRentalIncome',
            'ArrayOfApplicantGroup' => '\\TurnedAwayBOSS\\ArrayType\\ArrayOfApplicantGroup',
            'ApplicantGroup' => '\\TurnedAwayBOSS\\StructType\\ApplicantGroup',
            'ArrayOfApplicant' => '\\TurnedAwayBOSS\\ArrayType\\ArrayOfApplicant',
            'Applicant' => '\\TurnedAwayBOSS\\StructType\\Applicant',
            'Name' => '\\TurnedAwayBOSS\\StructType\\Name',
            'ArrayOfPhone' => '\\TurnedAwayBOSS\\ArrayType\\ArrayOfPhone',
            'Phone' => '\\TurnedAwayBOSS\\StructType\\Phone',
            'ArrayOfIdentification' => '\\TurnedAwayBOSS\\ArrayType\\ArrayOfIdentification',
            'Identification' => '\\TurnedAwayBOSS\\StructType\\Identification',
            'ArrayOfApplicantAddress' => '\\TurnedAwayBOSS\\ArrayType\\ArrayOfApplicantAddress',
            'ArrayOfEmployment' => '\\TurnedAwayBOSS\\ArrayType\\ArrayOfEmployment',
            'Employment' => '\\TurnedAwayBOSS\\StructType\\Employment',
            'EmploymentContact' => '\\TurnedAwayBOSS\\StructType\\EmploymentContact',
            'Income' => '\\TurnedAwayBOSS\\StructType\\Income',
            'OtherIncome' => '\\TurnedAwayBOSS\\StructType\\OtherIncome',
            'SelfEmploymentDetail' => '\\TurnedAwayBOSS\\StructType\\SelfEmploymentDetail',
            'ArrayOfAsset' => '\\TurnedAwayBOSS\\ArrayType\\ArrayOfAsset',
            'Asset' => '\\TurnedAwayBOSS\\StructType\\Asset',
            'ArrayOfLiability' => '\\TurnedAwayBOSS\\ArrayType\\ArrayOfLiability',
            'Liability' => '\\TurnedAwayBOSS\\StructType\\Liability',
            'ArrayOfBankruptcy' => '\\TurnedAwayBOSS\\ArrayType\\ArrayOfBankruptcy',
            'Bankruptcy' => '\\TurnedAwayBOSS\\StructType\\Bankruptcy',
            'ArrayOfOtherIncome' => '\\TurnedAwayBOSS\\ArrayType\\ArrayOfOtherIncome',
            'ArrayOfApplicantProperty' => '\\TurnedAwayBOSS\\ArrayType\\ArrayOfApplicantProperty',
            'ApplicantProperty' => '\\TurnedAwayBOSS\\StructType\\ApplicantProperty',
            'ArrayOfExistingMortgage' => '\\TurnedAwayBOSS\\ArrayType\\ArrayOfExistingMortgage',
            'ExistingMortgage' => '\\TurnedAwayBOSS\\StructType\\ExistingMortgage',
            'PushDealResponse' => '\\TurnedAwayBOSS\\StructType\\PushDealResponse',
            'Response' => '\\TurnedAwayBOSS\\StructType\\Response',
            'CountUpdatedDeals' => '\\TurnedAwayBOSS\\StructType\\CountUpdatedDeals',
            'CountUpdatedDealsResponse' => '\\TurnedAwayBOSS\\StructType\\CountUpdatedDealsResponse',
            'RecalcBRE' => '\\TurnedAwayBOSS\\StructType\\RecalcBRE',
            'RecalcBREResponse' => '\\TurnedAwayBOSS\\StructType\\RecalcBREResponse',
        );
    }
}
