<?php

namespace TurnedAwayBOSS\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AckSpecificSubmission StructType
 * @subpackage Structs
 */
class AckSpecificSubmission extends AbstractStructBase
{
    /**
     * The SubmissionId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $SubmissionId;
    /**
     * The Token
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Token;
    /**
     * The BOSS_Deal_ID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $BOSS_Deal_ID;
    /**
     * Constructor method for AckSpecificSubmission
     * @uses AckSpecificSubmission::setSubmissionId()
     * @uses AckSpecificSubmission::setToken()
     * @uses AckSpecificSubmission::setBOSS_Deal_ID()
     * @param int $submissionId
     * @param string $token
     * @param string $bOSS_Deal_ID
     */
    public function __construct($submissionId = null, $token = null, $bOSS_Deal_ID = null)
    {
        $this
            ->setSubmissionId($submissionId)
            ->setToken($token)
            ->setBOSS_Deal_ID($bOSS_Deal_ID);
    }
    /**
     * Get SubmissionId value
     * @return int
     */
    public function getSubmissionId()
    {
        return $this->SubmissionId;
    }
    /**
     * Set SubmissionId value
     * @param int $submissionId
     * @return \TurnedAwayBOSS\StructType\AckSpecificSubmission
     */
    public function setSubmissionId($submissionId = null)
    {
        // validation for constraint: int
        if (!is_null($submissionId) && !(is_int($submissionId) || ctype_digit($submissionId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($submissionId, true), gettype($submissionId)), __LINE__);
        }
        $this->SubmissionId = $submissionId;
        return $this;
    }
    /**
     * Get Token value
     * @return string|null
     */
    public function getToken()
    {
        return $this->Token;
    }
    /**
     * Set Token value
     * @param string $token
     * @return \TurnedAwayBOSS\StructType\AckSpecificSubmission
     */
    public function setToken($token = null)
    {
        // validation for constraint: string
        if (!is_null($token) && !is_string($token)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($token, true), gettype($token)), __LINE__);
        }
        $this->Token = $token;
        return $this;
    }
    /**
     * Get BOSS_Deal_ID value
     * @return string|null
     */
    public function getBOSS_Deal_ID()
    {
        return $this->BOSS_Deal_ID;
    }
    /**
     * Set BOSS_Deal_ID value
     * @param string $bOSS_Deal_ID
     * @return \TurnedAwayBOSS\StructType\AckSpecificSubmission
     */
    public function setBOSS_Deal_ID($bOSS_Deal_ID = null)
    {
        // validation for constraint: string
        if (!is_null($bOSS_Deal_ID) && !is_string($bOSS_Deal_ID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bOSS_Deal_ID, true), gettype($bOSS_Deal_ID)), __LINE__);
        }
        $this->BOSS_Deal_ID = $bOSS_Deal_ID;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \TurnedAwayBOSS\StructType\AckSpecificSubmission
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
