<?php

namespace TurnedAwayBOSS\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ApplicantGroup StructType
 * @subpackage Structs
 */
class ApplicantGroup extends AbstractStructBase
{
    /**
     * The ApplicantGroupTypeId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $ApplicantGroupTypeId;
    /**
     * The Applicants
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \TurnedAwayBOSS\ArrayType\ArrayOfApplicant
     */
    public $Applicants;
    /**
     * Constructor method for ApplicantGroup
     * @uses ApplicantGroup::setApplicantGroupTypeId()
     * @uses ApplicantGroup::setApplicants()
     * @param string $applicantGroupTypeId
     * @param \TurnedAwayBOSS\ArrayType\ArrayOfApplicant $applicants
     */
    public function __construct($applicantGroupTypeId = null, \TurnedAwayBOSS\ArrayType\ArrayOfApplicant $applicants = null)
    {
        $this
            ->setApplicantGroupTypeId($applicantGroupTypeId)
            ->setApplicants($applicants);
    }
    /**
     * Get ApplicantGroupTypeId value
     * @return string
     */
    public function getApplicantGroupTypeId()
    {
        return $this->ApplicantGroupTypeId;
    }
    /**
     * Set ApplicantGroupTypeId value
     * @uses \TurnedAwayBOSS\EnumType\ApplicantGroupType::valueIsValid()
     * @uses \TurnedAwayBOSS\EnumType\ApplicantGroupType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $applicantGroupTypeId
     * @return \TurnedAwayBOSS\StructType\ApplicantGroup
     */
    public function setApplicantGroupTypeId($applicantGroupTypeId = null)
    {
        // validation for constraint: enumeration
        if (!\TurnedAwayBOSS\EnumType\ApplicantGroupType::valueIsValid($applicantGroupTypeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \TurnedAwayBOSS\EnumType\ApplicantGroupType', is_array($applicantGroupTypeId) ? implode(', ', $applicantGroupTypeId) : var_export($applicantGroupTypeId, true), implode(', ', \TurnedAwayBOSS\EnumType\ApplicantGroupType::getValidValues())), __LINE__);
        }
        $this->ApplicantGroupTypeId = $applicantGroupTypeId;
        return $this;
    }
    /**
     * Get Applicants value
     * @return \TurnedAwayBOSS\ArrayType\ArrayOfApplicant|null
     */
    public function getApplicants()
    {
        return $this->Applicants;
    }
    /**
     * Set Applicants value
     * @param \TurnedAwayBOSS\ArrayType\ArrayOfApplicant $applicants
     * @return \TurnedAwayBOSS\StructType\ApplicantGroup
     */
    public function setApplicants(\TurnedAwayBOSS\ArrayType\ArrayOfApplicant $applicants = null)
    {
        $this->Applicants = $applicants;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \TurnedAwayBOSS\StructType\ApplicantGroup
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
