<?php

namespace TurnedAwayBOSS\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PushResponse StructType
 * @subpackage Structs
 */
class PushResponse extends AbstractStructBase
{
    /**
     * The Token
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Token;
    /**
     * The ResponseInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ResponseInfo;
    /**
     * Constructor method for PushResponse
     * @uses PushResponse::setToken()
     * @uses PushResponse::setResponseInfo()
     * @param string $token
     * @param string $responseInfo
     */
    public function __construct($token = null, $responseInfo = null)
    {
        $this
            ->setToken($token)
            ->setResponseInfo($responseInfo);
    }
    /**
     * Get Token value
     * @return string|null
     */
    public function getToken()
    {
        return $this->Token;
    }
    /**
     * Set Token value
     * @param string $token
     * @return \TurnedAwayBOSS\StructType\PushResponse
     */
    public function setToken($token = null)
    {
        // validation for constraint: string
        if (!is_null($token) && !is_string($token)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($token, true), gettype($token)), __LINE__);
        }
        $this->Token = $token;
        return $this;
    }
    /**
     * Get ResponseInfo value
     * @return string|null
     */
    public function getResponseInfo()
    {
        return $this->ResponseInfo;
    }
    /**
     * Set ResponseInfo value
     * @param string $responseInfo
     * @return \TurnedAwayBOSS\StructType\PushResponse
     */
    public function setResponseInfo($responseInfo = null)
    {
        // validation for constraint: string
        if (!is_null($responseInfo) && !is_string($responseInfo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($responseInfo, true), gettype($responseInfo)), __LINE__);
        }
        $this->ResponseInfo = $responseInfo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \TurnedAwayBOSS\StructType\PushResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
